package com.gxwebsoft.tower.controller;

import com.github.yulichang.wrapper.MPJLambdaWrapper;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.Company;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.entity.*;
import com.gxwebsoft.tower.service.TowerContractFinalSettleService;
import com.gxwebsoft.tower.param.TowerContractFinalSettleParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 项目结算书控制器
 *
 * @author 科技小王子
 * @since 2023-06-17 22:34:32
 */
@Api(tags = "项目结算书管理")
@RestController
@RequestMapping("/api/tower/tower-contract-final-settle")
public class TowerContractFinalSettleController extends BaseController {
    @Resource
    private TowerContractFinalSettleService towerContractFinalSettleService;

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("分页查询项目结算书")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerContractFinalSettle>> page(TowerContractFinalSettleParam param) {
        MPJLambdaWrapper<TowerContractFinalSettle> wrapper = new MPJLambdaWrapper<>();
        wrapper.selectAll(TowerContractFinalSettle.class)
                .select(TowerContract::getContactNumber)
                .select(TowerContract::getTotalInvoicingAmount)
                .select(TowerContract::getTotalIncomeAmount)
                .select(TowerContract::getEndDate)
                .select(Company::getCompanyName)
                .leftJoin(TowerContract.class, TowerContract::getContractId, TowerContractFinalSettle::getContractId)
                .leftJoin(Company.class, Company::getCompanyId, TowerContractFinalSettle::getSettleCompanyId);
        PageParam<TowerContractFinalSettle, TowerContractFinalSettleParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerContractFinalSettleService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(towerContractFinalSettleService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("查询全部项目结算书")
    @GetMapping()
    public ApiResult<List<TowerContractFinalSettle>> list(TowerContractFinalSettleParam param) {
        PageParam<TowerContractFinalSettle, TowerContractFinalSettleParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(towerContractFinalSettleService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(towerContractFinalSettleService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:list')")
    @OperationLog
    @ApiOperation("根据id查询项目结算书")
    @GetMapping("/{id}")
    public ApiResult<TowerContractFinalSettle> get(@PathVariable("id") Integer id) {
        return success(towerContractFinalSettleService.getById(id));
        // 使用关联查询
        //return success(towerContractFinalSettleService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:save')")
    @OperationLog
    @ApiOperation("添加项目结算书")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerContractFinalSettle towerContractFinalSettle) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerContractFinalSettle.setUserId(loginUser.getUserId());
        }
        if (towerContractFinalSettleService.save(towerContractFinalSettle)) {
            return success(towerContractFinalSettle.getContractFinalSettleId());
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:update')")
    @OperationLog
    @ApiOperation("修改项目结算书")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerContractFinalSettle towerContractFinalSettle) {
        if (towerContractFinalSettleService.updateById(towerContractFinalSettle)) {
            return success(towerContractFinalSettle.getContractFinalSettleId());
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:remove')")
    @OperationLog
    @ApiOperation("删除项目结算书")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerContractFinalSettleService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:save')")
    @OperationLog
    @ApiOperation("批量添加项目结算书")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerContractFinalSettle> list) {
        if (towerContractFinalSettleService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:update')")
    @OperationLog
    @ApiOperation("批量修改项目结算书")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerContractFinalSettle> batchParam) {
        if (batchParam.update(towerContractFinalSettleService, "contract_final_settle_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerContractFinalSettle:remove')")
    @OperationLog
    @ApiOperation("批量删除项目结算书")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerContractFinalSettleService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
